AutoRepair = {};

AutoRepair.metadata = {
	interface = "FS25 ...", --convert LS22 to LS25
	title = "AutoRepair",
	notes = "Dieser Mod Repariert alle Fahrzeuge um ~Mitternacht. (Keine Missions Fahrzeuge)",
	author = "(by HappyLooser)",
	version = "1.0.0.0",
	build = 3,
	datum = " 28.12.2023",
	update = " 01.12.2024",
	web = "no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

function AutoRepair:loadMap(mapName)
	print("---loading ".. tostring(AutoRepair.metadata.title).. " ".. tostring(AutoRepair.metadata.version).. "(#".. tostring(AutoRepair.metadata.build).. ") ".. tostring(AutoRepair.metadata.author).. "---")	
	AutoRepair.canRepair = true;
	AutoRepair.isHour = g_currentMission.environment.currentHour;
	if AutoRepair.isHour > 23 then
		AutoRepair.isHour = 0
	end;
	if not AutoRepair:isMP() or AutoRepair:getDetiServer() or AutoRepair:getHostServer() then
		autorepair = {};
		function autorepair:update(dt)
			if g_currentMission.environment.currentHour == AutoRepair.isHour and AutoRepair.canRepair then
				for _, vehicle in pairs(g_currentMission.vehicleSystem.vehicles) do
					if vehicle ~= nil and vehicle.finishedLoading == true and vehicle.repairVehicle ~= nil then
						local missionsVehicle = vehicle.propertyState >= 4 or (vehicle.propertyState >= 2 and vehicle.activeMissionId ~= nil and vehicle.activeMissionId > 0);
						if vehicle.ownerFarmId ~= 0 and not missionsVehicle then		
							vehicle:repairVehicle(true);
						end;
					end;
				end;		
				AutoRepair.canRepair = false;
				AutoRepair.isHour = g_currentMission.environment.currentHour + 2
				if AutoRepair.isHour > 23 then
					AutoRepair.isHour = 0
				end;
			end;	
			if g_currentMission.environment.currentHour ~= AutoRepair.isHour and not AutoRepair.canRepair then
				AutoRepair.canRepair = true;
			end;		
		end;
		BaseMission.update = Utils.prependedFunction(BaseMission.update, autorepair.update);
	else	
		print("---".. tostring(AutoRepair.metadata.title).. " not loaded for MP Client---");
	end;
end;
addModEventListener(AutoRepair);

function AutoRepair:getDetiServer()	
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;	
end;

function AutoRepair:getHostServer()		
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer == nil and g_currentMission.missionDynamicInfo.isMultiplayer;	
end;

function AutoRepair:isMP()		
	return g_currentMission.missionDynamicInfo.isMultiplayer;	
end;
